searchNodes=[{"doc":"","ref":"Exun.html","title":"Exun","type":"module"},{"doc":"","ref":"Exun.html#conctostr/6","title":"Exun.conctostr/6","type":"function"},{"doc":"Tree equality, normalize compounds '' and '+' because {,{,1,2},{,3,4}} == {,{,1,3},{,2,4}} so transform both trees to {{:m,}[1,2,3,4]} before compare","ref":"Exun.html#eq/2","title":"Exun.eq/2","type":"function"},{"doc":"","ref":"Exun.html#eval/1","title":"Exun.eval/1","type":"function"},{"doc":"Parse and evaluate an expression. If ast is true returns de AST tuple, if it is false return a human-readable (and parseable) expression iex&gt; Exun.eval &quot;x[m^2]+4[cm^2]&quot;,%{&quot;x&quot;=&gt;&quot;3&quot;} &quot;3.0004[m^2]&quot;","ref":"Exun.html#eval/2","title":"Exun.eval/2","type":"function"},{"doc":"","ref":"Exun.html#eval_ast/1","title":"Exun.eval_ast/1","type":"function"},{"doc":"","ref":"Exun.html#eval_ast/2","title":"Exun.eval_ast/2","type":"function"},{"doc":"","ref":"Exun.html#innertostr/1","title":"Exun.innertostr/1","type":"function"},{"doc":"Parse a math expression, without context: iex(1)&gt; Exun.parse &quot;x*y^(1+x)&quot; {:mult, {:vari, &quot;x&quot;}, {:elev, {:vari, &quot;y&quot;}, {:suma, {:numb, 1}, {:vari, &quot;x&quot;}}}}","ref":"Exun.html#parse/1","title":"Exun.parse/1","type":"function"},{"doc":"Parse a math expression, not a 'equality', with context definitions For example, express 'x' squared meters, and then define x to be 3. iex&gt; Exun.parse( &quot;x[m^2]&quot;, %{&quot;x&quot;=&gt;&quot;3&quot;}) {{:unit, {:vari, &quot;x&quot;}, {:elev, {:vari, &quot;m&quot;}, {:numb, 2}}}, %{&quot;x&quot; =&gt; {:numb, 3}}}returns a tuple {expression, parsed_conext} where expression is a tuple that holds math AST and parsed_context is a map whith all equalities (definitions) parsed as &quot;name&quot; =&gt; expression","ref":"Exun.html#parse/2","title":"Exun.parse/2","type":"function"},{"doc":"","ref":"Exun.html#parse_text/1","title":"Exun.parse_text/1","type":"function"},{"doc":"","ref":"Exun.html#repl/2","title":"Exun.repl/2","type":"function"},{"doc":"Expand definitions in context into main tree expression until no more expansion is posssible","ref":"Exun.html#replace/2","title":"Exun.replace/2","type":"function"},{"doc":"Translate tree to human readable math expression: iex(1)&gt; {_tree, _deps} = Exun.parse &quot;4*x^(y+1)/z&quot;,%{&quot;z&quot;=&gt;&quot;y+1&quot;} {{:divi, {:mult, {:numb, 4}, {:elev, {:vari, &quot;x&quot;}, {:suma, {:vari, &quot;y&quot;}, {:numb, 1}}}}, {:vari, &quot;z&quot;}}, %{&quot;z&quot; =&gt; {:suma, {:vari, &quot;y&quot;}, {:numb, 1}}}}","ref":"Exun.html#tostr/1","title":"Exun.tostr/1","type":"function"},{"doc":"","ref":"Exun.Collect.html","title":"Exun.Collect","type":"module"},{"doc":"Returns commom base for two trees. Used for collect {:m,:suma}","ref":"Exun.Collect.html#cbs/3","title":"Exun.Collect.cbs/3","type":"function"},{"doc":"Change power sign of tree","ref":"Exun.Collect.html#chpow/1","title":"Exun.Collect.chpow/1","type":"function"},{"doc":"Change sign of tree","ref":"Exun.Collect.html#chsign/1","title":"Exun.Collect.chsign/1","type":"function"},{"doc":"","ref":"Exun.Collect.html#coll/1","title":"Exun.Collect.coll/1","type":"function"},{"doc":"","ref":"Exun.Collect.html#denorm/1","title":"Exun.Collect.denorm/1","type":"function"},{"doc":"","ref":"Exun.Collect.html#get_base/2","title":"Exun.Collect.get_base/2","type":"function"},{"doc":"","ref":"Exun.Collect.html#get_coefs/1","title":"Exun.Collect.get_coefs/1","type":"function"},{"doc":"","ref":"Exun.Collect.html#get_isol/2","title":"Exun.Collect.get_isol/2","type":"function"},{"doc":"","ref":"Exun.Collect.html#get_rest/1","title":"Exun.Collect.get_rest/1","type":"function"},{"doc":"","ref":"Exun.Collect.html#maxbase/1","title":"Exun.Collect.maxbase/1","type":"function"},{"doc":"","ref":"Exun.Collect.html#maxbasef/2","title":"Exun.Collect.maxbasef/2","type":"function"},{"doc":"","ref":"Exun.Collect.html#mk/1","title":"Exun.Collect.mk/1","type":"function"},{"doc":"","ref":"Exun.Collect.html#mkrec/1","title":"Exun.Collect.mkrec/1","type":"function"},{"doc":"Normalize tree so :mult and :suma are converted to list: {:mult,{:mult,a,b},c} -&gt; {{:m,:mult},[a,b,c]}","ref":"Exun.Collect.html#norm/1","title":"Exun.Collect.norm/1","type":"function"},{"doc":"Simplify literals, reduce to one number and one unit when possible","ref":"Exun.Collect.html#solve_literals/1","title":"Exun.Collect.solve_literals/1","type":"function"},{"doc":"","ref":"Exun.Cyclic.html","title":"Exun.Cyclic","type":"module"},{"doc":"Get a list of variables down a tree, checking cyclic definition from 'context' user defs","ref":"Exun.Cyclic.html#check/1","title":"Exun.Cyclic.check/1","type":"function"},{"doc":"Check cyclic definitins in 'context', a map that holds values like %{&quot;f&quot; =&gt; &quot;x^2+2*x+3&quot;}. If you pass a cyclic map this function detects it, for example: %{&quot;a&quot;=&gt;&quot;b&quot;, &quot;b&quot;=&gt;&quot;c&quot;, &quot;c&quot;=&gt;&quot;a&quot;}","ref":"Exun.Cyclic.html#check_definitions/1","title":"Exun.Cyclic.check_definitions/1","type":"function"},{"doc":"Recursively expands defs and find variables on what definitions depends.","ref":"Exun.Cyclic.html#check_expand/2","title":"Exun.Cyclic.check_expand/2","type":"function"},{"doc":"Select only vars","ref":"Exun.Cyclic.html#extract_vars/2","title":"Exun.Cyclic.extract_vars/2","type":"function"},{"doc":"Initial parse of definitions in map 'context'","ref":"Exun.Cyclic.html#maps_all/1","title":"Exun.Cyclic.maps_all/1","type":"function"},{"doc":"","ref":"Exun.Fun.html","title":"Exun.Fun","type":"module"},{"doc":"","ref":"Exun.Fun.html#der/2","title":"Exun.Fun.der/2","type":"function"},{"doc":"","ref":"Exun.Fun.html#deriv/2","title":"Exun.Fun.deriv/2","type":"function"},{"doc":"","ref":"Exun.Fun.html#fcall/2","title":"Exun.Fun.fcall/2","type":"function"},{"doc":"","ref":"Exun.Unit.html","title":"Exun.Unit","type":"module"},{"doc":"Convert units, for example iex&gt; import Exun.Unit iex&gt; &quot;120[Km/h]&quot; |&gt; convert(&quot;m/s&quot;) &quot;33.333333333333336[m/s]&quot;","ref":"Exun.Unit.html#convert/2","title":"Exun.Unit.convert/2","type":"function"},{"doc":"Convert first unit to the second unit in convert: u1 = Exun.parse &quot;3[m]&quot; u2 = Exun.parse &quot;1[cm]&quot; Exum.Units.convert(u1,u2,%{}) |&gt; Exum.tostr() &quot;300[cm]&quot;","ref":"Exun.Unit.html#convert/3","title":"Exun.Unit.convert/3","type":"function"},{"doc":"","ref":"Exun.Unit.html#exps_tostr/1","title":"Exun.Unit.exps_tostr/1","type":"function"},{"doc":"","ref":"Exun.Unit.html#factorize/2","title":"Exun.Unit.factorize/2","type":"function"},{"doc":"Factorize unit2 from u1, for example iex(1)&gt; {u1,d} = Exun.parse &quot;1[kmKgA/h^2]&quot;, %{} {u2,d} = Exun.parse &quot;1[N]&quot;, %{} factorized = Exun.Unit.factorize(u1,u2,%{}) Exum.Tree.tostr factorized &quot;7.566861148315854e-4[N*A]&quot;","ref":"Exun.Unit.html#factorize/3","title":"Exun.Unit.factorize/3","type":"function"},{"doc":"Transform a name into a unit, looking at fundamentals, conversions, context and prefixes, in that search order.","ref":"Exun.Unit.html#get_def/2","title":"Exun.Unit.get_def/2","type":"function"},{"doc":"","ref":"Exun.Unit.html#help/0","title":"Exun.Unit.help/0","type":"function"},{"doc":"Sum of two units","ref":"Exun.Unit.html#sum/4","title":"Exun.Unit.sum/4","type":"function"},{"doc":"","ref":"Exun.Unit.html#toSI/1","title":"Exun.Unit.toSI/1","type":"function"},{"doc":"Convert unit to International System args: unit","ref":"Exun.Unit.html#to_si/1","title":"Exun.Unit.to_si/1","type":"function"},{"doc":"Convert unit to International System args: {coef, ast}, parsed_context, current_exponent, exponents returns: {newcoef, exponents}","ref":"Exun.Unit.html#to_si/4","title":"Exun.Unit.to_si/4","type":"function"}]